routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
/*
Route::get('/', function () {
    return view('frontend.index');
});
*/

/** ------------------------------------------
 *  Language defaults
 *  ------------------------------------------
 */
$language = Config::get('app.locale');
$languages = Config::get('app.locales');


/** ------------------------------------------
 *  Check in the URL, then HTTP_ACCEPT_LANGUAGE
 *  ------------------------------------------
 */
$routeLanguage = Request::segment(1);
if(in_array($routeLanguage, $languages)) {
    $language = $routeLanguage;
} else {
 	$routeLanguage = substr(Request::instance()->server->get('HTTP_ACCEPT_LANGUAGE'), 0, 2);
	if(in_array($routeLanguage, $languages)) {
	    $language = $routeLanguage;
	}
}

/** ------------------------------------------
 *  Set current language, redirect home
 *  ------------------------------------------
 */
Config::set('app.locale', $language);
App::setLocale($language);

Route::group(['domain' => env('ADMIN_URL')], function()
{
	Auth::routes();
	Route::any('/', function()
    {
        return view('admin.auth.login');
    });
    
});

Route::get('/', function() {
    return Redirect::to(App::getLocale());
});

Auth::routes();

Route::group(['prefix' => $language], function()
{
	Auth::routes();
	Route::resource('/', 'HomeController');

	Route::get('contact', function () {
	    return view('frontend.pages.contact');
	});

	Route::get('checkout', function () {
	    return view('frontend.pages.checkout');
	});

	

	Route::get('about', function () {
	    return view('frontend.pages.about');
	});

	Route::post('/sendcontactus','HomeController@contactus');
	Route::post('/sendcontact','HomeController@contact');

	Route::post('/subscribe','HomeController@subscribe');

	Route::get('services','HomeController@services');
	Route::get('services/{id}','HomeController@getServices');

	//Route::resource('/register','Auth\\RegisterController');
	

	Route::get('/checkout/{id}','HomeController@tocheckout');

	Route::post('/paymentstatus', 'HomeController@paymentstatus');
	Route::post('/payment-status', 'Client\\InvoicesController@paymentstatus');
	Route::post('/payinvoice', 'HomeController@method');



	Route::group(['prefix' => 'panel', 'middleware' => ['auth', 'role:client']], function() {
		
	  Route::resource('/profile', 'Client\\ProfileController');
	  Route::get('/docs','Client\\ClientController@documents');
	  Route::resource('/invoices', 'Client\\InvoicesController');
	  Route::resource('/password', 'Client\\PasswordController');
	  Route::resource('/', 'Client\\ClientController');
	  Route::get('/downloadinvoice/{id}', 'PDFInvoiceController@pdf');	
      Route::get('/download/{file}', 'Client\\ClientController@downloadFile');
	});

});


Route::group(['prefix' => 'admin', 'middleware' => ['auth','role:admin|superadmin|employee']], function() {

	Route::resource('/users','Admin\\UserController',['middleware'=>['role:superadmin|admin']]);
	Route::resource('/whyus','Admin\\WhyUsController',['middleware'=>['role:superadmin|admin']]);
	Route::resource('/roles','Admin\\RoleController',['middleware'=>['role:superadmin']]);
	Route::resource('/permissions','Admin\\PermissionController',['middleware'=>['role:superadmin']]);
	Route::resource('/packet', 'Admin\\PacketsController',['middleware'=>['permission:manage-packet']]);
	Route::get ('/downloadinvoice/{id}', 'PDFInvoiceController@pdf');
	Route::get ('/subscribers/export', 'PDFInvoiceController@export');

	Route::resource('/dashboard','Admin\\DashboardController');
	Route::resource('/customer-status', 'Admin\\CustomerStatusController',['middleware'=>['permission:manage-statuses']]);
	Route::resource('/service-items', 'Admin\\ServiceItemsController',['middleware'=>['permission:manage-packet']]);
	Route::resource('/potential', 'Admin\\PotentialController',['middleware'=>['permission:manage-potential-customer']]);
	Route::resource('/invoice', 'Admin\\InvoiceController',['middleware'=>['permission:view-listedinvoices']]);

	//Potential Customers
	Route::resource('/potential', 'Admin\\PotentialController',['middleware'=>['permission:manage-potential-customer']]);
	Route::get('/potential/tocustomer/{id}', 'Admin\\PotentialController@toCustomer',['middleware'=>['permission:manage-potential-customer']]);
	Route::post('/potential/comment','Admin\\PotentialController@storecomment',['middleware'=>['permission:manage-potential-customer']]);
	Route::get('/potential/comment/{id}', 'Admin\\PotentialController@deleteComment',['middleware'=>['permission:manage-potential-customer']]);

	
	Route::get('/invoice/custominvoice/{id}', 'Admin\\InvoiceController@showcustominvoice',['middleware'=>['permission:view-listedinvoices']]);
	Route::get('/invoice/packetinvoice/{id}', 'Admin\\InvoiceController@showpacketinvoice',['middleware'=>['permission:view-listedinvoices']]);
	//Route::post('/invoice/custominvoice/update', 'Admin\\InvoiceController@updatecustompaymentinvoice');

	Route::post('/invoice/custominvoice/', [
	'as' => 'invoice_path',
	'uses' => 'Admin\\InvoiceController@displayForm',
	'middleware'=>['permission:view-listedinvoices']
	]);

	Route::post('/invoice/custominvoice/create', [
	'as' => 'invoice_update',
	'uses' => 'Admin\\InvoiceController@updatecustompaymentinvoice',
	'middleware'=>['permission:view-listedinvoices']
	]);

	Route::post('/invoice/packetinvoice/create', [
	'as' => 'invoice_packet_update',
	'uses' => 'Admin\\InvoiceController@updatepacketpaymentinvoice',
	'middleware'=>['permission:view-listedinvoices']
	]);

	Route::get('/invoice/{id}', [
	'as' => 'delete_invoice',
	'uses' => 'Admin\\InvoiceController@destroy',
	'middleware'=>['permission:view-listedinvoices']
	]);

	//PACKET INVOICE
	Route::post('/invoice/packetinvoice/', [
	'as' => 'invoice_packet_path',
	'uses' => 'Admin\\InvoiceController@displayFormPacket',
	'middleware'=>['permission:view-listedinvoices']
	]);

	Route::post('/invoice/packetinvoice/add','Admin\\InvoiceController@storePacketInvoice',['middleware'=>['permission:view-listedinvoices']]);

	Route::get('product_prices', 'Admin\\InvoiceController@product_prices');
	//END INVOICE PACKET

	Route::resource('/customer', 'Admin\\CustomerController',['middleware'=>['permission:view-customer,delete-customer,create-customer']]);
	Route::post('/customer/comment','Admin\\CustomerController@storecomment',['middleware'=>['permission:create-comment']]);
	Route::get('/customer/comment/{id}', 'Admin\\CustomerController@deleteComment');
	Route::get('/customer/invoice/{id}', 'Admin\\CustomerController@deleteInvoice',['middleware'=>['permission:delete-invoice']]);

	Route::post('/customer/allowlogin', array('as' => 'allowLogin', 'uses' => 'Admin\\CustomerController@allowlogin'));
	Route::post('/customer/attachdoc', array('as' => 'attach', 'uses' => 'Admin\\CustomerController@attachdocument',['middleware'=>['permission:upload-documents']]));
	Route::post('/customer/attachdoc/delete', 'Admin\\CustomerController@deleteDocument');
	/*Route::delete('/customer/attachdoc/delete', ['as'=>'attachments.destroy', 'uses'=>'Admin\\CustomerController@deleteDocument']);*/
   /*Route::delete('/uploads/documents/{id}', 'Admin\\CustomerController@deleteDocument');*/
    
    Route::get('/download/{file}', 'Admin\\CustomerController@downloadFile');

	//Apply credits
	Route::resource('/credits', 'Admin\\CreditsController',['middleware'=>['permission:manage-credits']]);

	//Todolist
	Route::post('/customer/todolist','Admin\\CustomerController@createtask',['middleware'=>['permission:create-task']]);
	Route::get('/customer/todolist/{id}', 'Admin\\CustomerController@deleteTask');
	Route::get('/customer/todolist/done/{id}', 'Admin\\CustomerController@doneTask');

	//Profile
	Route::resource('/profile', 'Admin\\ProfileController');

	//Settings
	Route::resource('/settings', 'Admin\\SettingsController',['middleware'=>['role:superadmin|admin']]);

	//Pages
	Route::resource('/pages', 'Admin\\PagesController',['middleware'=>['role:superadmin|admin']]);

	//Tasks
	Route::resource('/tasks', 'Admin\\TodolistController');
	Route::post('/tasks','Admin\\TodolistController@createtask',['middleware'=>['permission:create-task']]);
	Route::get('/tasks/done/{id}', 'Admin\\TodolistController@doneTask');
	Route::get('/tasks/toedit/{id}', 'Admin\\TodolistController@toeditTask');
	Route::post('/tasks/edit/{id}', 'Admin\\TodolistController@editTask');

	//Generate new password
	Route::post('/customer/newpassword', 'Admin\\CustomerController@generateNewPassword');

	//Subscriber
	Route::resource('/subscriber', 'Admin\\SubscriberController',['middleware'=>['role:superadmin|admin']]);
});

app/Models/Role.php
<?php
namespace App\Models;

use Zizaco\Entrust\EntrustRole;

class Role extends EntrustRole
{
	 /**
     * The database table used by the model.
     *
     * @var string
     */
    protected $table = 'role';

    /**
    * The database primary key value.
    *
    * @var string
    */
    protected $primaryKey = 'id';

    /**
     * Attributes that should be mass-assignable.
     *
     * @var array
     */
    protected $fillable = ['name','display_name','description'];

    public function permission()
    {
        return $this->belongsToMany('App\Models\Permission','permission_role');
    }

    public function user()
    {
        return $this->belongsToMany('App\User','user_id');
    }
}

app/Http/Controllers/Admin/RoleController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Role;
use App\Models\Permission;
use DB;

class RoleController extends Controller
{

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $roles = Role::orderBy('id','DESC')->paginate(25);

        $permissions = Permission::orderBy('id','DESC')->paginate(25);

        return view('admin.roles.index',compact('roles','permissions'))
            ->with('i', ($request->input('page', 1) - 1) * 5);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $permission = Permission::get();
        return view('admin.roles.create',compact('permission'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'name' => 'required|unique:roles,name',
            'display_name' => 'required',
            'description' => 'required',
            'permission' => 'required',
        ]);

        $role = new Role();
        $role->name = $request->input('name');
        $role->display_name = $request->input('display_name');
        $role->description = $request->input('description');
        $role->save();

        foreach ($request->input('permission') as $key => $value) {
            $role->attachPermission($value);
        }

        return redirect('/admin/roles/')
                        ->with('success','Role created successfully');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $role = Role::find($id);
        $rolePermissions = Permission::join("permission_role","permission_role.permission_id","=","permissions.id")
            ->where("permission_role.role_id",$id)
            ->get();

        return view('admin.roles.show',compact('role','rolePermissions'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $role = Role::find($id);
        //$permission = Permission::get();
        //$rolePermissions = DB::table("permission_role")->where("permission_role.role_id",$id)
        //    ->pluck('permission_role.permission_id','permission_role.permission_id');

        $permission = Permission::pluck('display_name', 'id');
        $rolePermissions = $role->permission->pluck('id')->toArray();

        return view('admin.roles.edit',compact('role','permission','rolePermissions'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $this->validate($request, [
            'display_name' => 'required',
            'description' => 'required',
            'permission' => 'required',
        ]);

        $role = Role::find($id);
        $role->display_name = $request->input('display_name');
        $role->description = $request->input('description');
        $role->save();

        DB::table("permission_role")->where("permission_role.role_id",$id)
            ->delete();

        foreach ($request->input('permission') as $key => $value) {
            $role->attachPermission($value);
        }

        return redirect('/admin/roles/')
                        ->with('success','Role updated successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        DB::table("roles")->where('id',$id)->delete();
        return redirect('/admin/roles/')
                        ->with('success','Role deleted successfully');
    }
}

resources/views/admin/roles/create.blade.php
@extends('layouts.app')
 
@section('content')
<div class="container">
	<div class="row">
	    <div class="col-md-12">
	        <div class="pull-left">
	            <h2>Create New Role</h2>
	        </div>
	        <div class="pull-right">
	            <a class="btn btn-primary btn-xs" href="/admin/roles/"><i aria-hidden="true" class="fa fa-times-circle"></i> Cancel</a>
	        </div>
	    </div>
	</div>

	@if (count($errors) > 0)
		<div class="alert alert-danger">
			<strong>Whoops!</strong> There were some problems with your input.<br><br>
			<ul>
				@foreach ($errors->all() as $error)
					<li>{{ $error }}</li>
				@endforeach
			</ul>
		</div>
	@endif

	{!! Form::open(array('route' => 'roles.store','method'=>'POST')) !!}
	<div class="row">

		<div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Name:</strong>
                {!! Form::text('name', null, array('placeholder' => 'Name','class' => 'form-control')) !!}
            </div>
        </div>

		<div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Display Name:</strong>
                {!! Form::text('display_name', null, array('placeholder' => 'Display Name','class' => 'form-control')) !!}
            </div>
        </div>

        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Description:</strong>
                {!! Form::textarea('description', null, array('placeholder' => 'Description','class' => 'form-control','style'=>'height:100px')) !!}
            </div>
        </div>

        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Permission:</strong>
                <br/>
                @foreach($permission as $value)
                	<label>{{ Form::checkbox('permission[]', $value->id, false, array('class' => 'name')) }}
                	{{ $value->display_name }}</label>
                	<br/>
                @endforeach
            </div>
        </div>

        <div class="col-xs-12 col-sm-12 col-md-12 text-center">
				<button type="submit" class="btn btn-primary">Submit</button>
        </div>

	</div>
	{!! Form::close() !!}
</div>
@endsection

resources/views/admin/roles/edit.blade.php
@extends('layouts.app')
 
@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                	Edit Role
                	 <div class="pull-right">
			            <a class="btn btn-primary btn-xs" href="/admin/roles/"><i aria-hidden="true" class="fa fa-times-circle"></i> Cancel</a>
			        </div>
                </div>
                <div class="panel-body">
                	
					@if (count($errors) > 0)
						<div class="alert alert-danger">
							<strong>Whoops!</strong> There were some problems with your input.<br><br>
							<ul>
								@foreach ($errors->all() as $error)
									<li>{{ $error }}</li>
								@endforeach
							</ul>
						</div>
					@endif

					{!! Form::model($role, ['method' => 'PATCH','route' => ['roles.update', $role->id]]) !!}
					<div class="row">
						<div class="col-xs-12 col-sm-12 col-md-12">
				            <div class="form-group">
				                <strong>Name: </strong>{{ $role->name }}
				            </div>
				        </div>
						<div class="col-xs-12 col-sm-12 col-md-12">
				            <div class="form-group">
				                <strong>Display name:</strong>
				                {!! Form::text('display_name', null, array('placeholder' => 'Name','class' => 'form-control')) !!}
				            </div>
				        </div>

				        <div class="col-xs-12 col-sm-12 col-md-12">
				            <div class="form-group">
				                <strong>Description:</strong>
				                {!! Form::textarea('description', null, array('placeholder' => 'Description','class' => 'form-control','style'=>'height:100px')) !!}
				            </div>
				        </div>

				        <div class="col-xs-12 col-sm-12 col-md-12">
				            <div class="form-group">
				                <strong>Permission:</strong>
				                <br/>

								@foreach($permission as $ingd => $ing)
					                <div class="col-md-3">
					                    <label class="checkbox-inline">
		                        {{ Form::checkbox('permission[]', $ingd, (in_array($ingd, $rolePermissions) ? true : null)) }}
					             {{ $ing }}
					                    </label>
					                </div>
					        @endforeach
				            </div>
				        </div>

				        <div class="col-xs-12 col-sm-12 col-md-12 text-center">
								<button type="submit" class="btn btn-primary">Submit</button>
				        </div>

					</div>
					{!! Form::close() !!}

                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/admin/roles/index.blade.php
@extends('layouts.app')
 
@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading" style="background: rgb(4, 105, 154); color: rgb(255, 255, 255);">
                	Role Management
                	 <div class="pull-right">
			            <a class="btn btn-primary btn-xs" href="/admin/roles/create"><i aria-hidden="true" class="fa fa-plus"></i> Create New Role</a>
			        </div>
                </div>
                <div class="panel-body">
                 @if ($message = Session::get('success'))
					<div class="alert alert-success">
						<p>{{ $message }}</p>
					</div>
				@endif
               		<table class="table table-bordered table-striped">
						<tr>
							<th>No</th>
							<th>Name</th>
							<th>Display Name</th>
							<th>Description</th>
							<th width="280px">Action</th>
						</tr>
					@foreach ($roles as $key => $role)
					<tr>
						<td>{{ ++$i }}</td>
						<td>{{ $role->name }}</td>
						<td>{{ $role->display_name }}</td>
						<td>{{ $role->description }}</td>
						<td>
							<a class="btn btn-info btn-xs" href="{{ route('roles.show',$role->id) }}">Show</a>
							
							<a class="btn btn-primary btn-xs" href="/admin/roles/{{ $role->id }}/edit">Edit</a>
							

							
							{!! Form::open(['method' => 'DELETE','route' => ['roles.destroy', $role->id],'style'=>'display:inline']) !!}
				            {!! Form::submit('Delete', ['class' => 'btn btn-danger btn-xs']) !!}
				        	{!! Form::close() !!}
				        	
						</td>
					</tr>
					@endforeach
					</table>

					{!! $roles->render() !!}
                </div>
            </div>
        </div>

<div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading" style="background: rgb(4, 105, 154); color: rgb(255, 255, 255);">
                	Permission Management
                	 <div class="pull-right">
		            	<a class="btn btn-primary btn-xs" href="/admin/permissions/create"><i aria-hidden="true" class="fa fa-plus"></i> Create Permission</a>
			        </div>
                </div>
                <div class="panel-body">
                 @if ($message = Session::get('permission_success'))
					<div class="alert alert-success">
						<p>{{ $message }}</p>
					</div>
				@endif
               		<table class="table table-bordered table-striped">
						<tr>
							<th>No</th>
							<th>Name</th>
							<th>Display Name</th>
							<th>Description</th>
							<th width="280px">Action</th>
						</tr>
					@foreach ($permissions as $key => $permission)
					<tr>
						<td>{{ ++$i }}</td>
						<td>{{ $permission->name }}</td>
						<td>{{ $permission->display_name }}</td>
						<td>{{ $permission->description }}</td>
						<td>
							<a class="btn btn-info btn-xs" href="{{ route('permissions.show',$permission->id) }}">Show</a>
							
							<a class="btn btn-primary btn-xs" href="/admin/permissions/{{ $permission->id }}/edit">Edit</a>
							

							
							{!! Form::open(['method' => 'DELETE','route' => ['permissions.destroy', $permission->id],'style'=>'display:inline']) !!}
				            {!! Form::submit('Delete', ['class' => 'btn btn-danger btn-xs']) !!}
				        	{!! Form::close() !!}
				        	
						</td>
					</tr>
					@endforeach
					</table>

					{!! $permissions->render() !!}
                </div>
            </div>
        </div>

    </div>
</div>
@endsection

resources/views/admin/roles/show.blade.php
@extends('layouts.app')
 
@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                	Show Role
                	 <div class="pull-right">
			            <a class="btn btn-primary btn-xs" href="{{ route('roles.index') }}"> Back</a>
			        </div>
                </div>
                <div class="panel-body">
                	<div class="col-xs-12 col-sm-12 col-md-12">
		            <div class="form-group">
			                <strong>Name:</strong>
			                {{ $role->display_name }}
			            </div>
			        </div>

			        <div class="col-xs-12 col-sm-12 col-md-12">
			            <div class="form-group">
			                <strong>Description:</strong>
			                {{ $role->description }}
			            </div>
			        </div>

			        <div class="col-xs-12 col-sm-12 col-md-12">
			            <div class="form-group">
			                <strong>Permissions:</strong>
			                @if(!empty($rolePermissions))
								@foreach($rolePermissions as $v)
									<label class="label label-success">{{ $v->display_name }}</label>
								@endforeach
							@endif
			            </div>
			        </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection